	LIST p=PIC16F877A
	#include <P16F877A.INC>
	__CONFIG 0x3F39
;======================================
	cblock 0x20		;   
	DS_DIG1			;1  
	DS_DIG2			;2  
	DS_DIG3			;3  
	DS_DIG4			;4  
	DIG_RECEIVE_NUM		;  
	endc			;  
;======================================
	org 0x00		;      
	goto PIC_Initial	;  
	org 0x05		;     ,  
				;005?   ,     004
				;,  004 -  ,  
				;    
;======================================
PIC_Initial:			;  
;-- Clear Registers ----	;    
	clrf PORTA		
	clrf PORTB
	clrf PORTC
	clrf PORTD
	clrf PORTE
	clrf TMR0		; Timer_0
	clrf FSR		;    
	clrf PIR1		;   
	movlw 0x0F		;     
	movwf DS_DIG1		;  ..
	movwf DS_DIG2		;.. ..
	movwf DS_DIG3		;....
	movwf DS_DIG4		;..
	movlw 0x20		;   020..
	movwf DIG_RECEIVE_NUM	;..   

;-- Configuration I/O ---	; ,   
;<< Bank 1 >>
	bsf STATUS, RP0		;  1
	movlw 0x06		;    ..
	movwf ADCON1		;..  PORT  PORTE    
	movlw b'11110000'	; ..
	movwf TRISA		;..   
	clrf TRISC		;    

;-- Configuration Timer_0 ---	; Timer_0,    	
	movlw b'11010001'	;     ..
	movwf OPTION_REG	;..  1/4

;-- Configuration PSP -------	;   ..
	movlw b'00010111'	;..    PORTD..
	movwf TRISE		;..    PORTE
;<< Bank 0 >>
	bcf STATUS, RP0		;  0
;======================================
Main_Cycle:			;        .
;---------------------------
;-- Receive Inform --------	;    PORTD
	btfss PIR1, PSPIF	;,     PSP(  )
	goto Indicator		; ,     
	movf DIG_RECEIVE_NUM, W	; ,     
	movwf FSR		;       
;----------------------
;-- Read PORTD --------		;  ,  
	movf PORTD, W		;   D ..
	movwf INDF		;   ,      FRS
;----------------------
	bcf PIR1, PSPIF		;     PSP
	incf DIG_RECEIVE_NUM	;     1
	movf DIG_RECEIVE_NUM, W	;,   
	addlw .220		;   220
	btfss STATUS, C		; ,      256
	goto Indicator		; ,,    4  
	movlw 0x20		; ,     020
	movwf DIG_RECEIVE_NUM	;      

;---------------------------
;-- Indicator ----------	;       
Indicator:
	movlw 0x20		;   020..
	movwf FSR		;..     
	clrf PORTA		;  ,    
	bsf STATUS, C		; ,  
;---------------------------
Display_Cycle:
	bcf INTCON, TMR0IF	; _0.    
				;  
;-- Display Off -------
	bsf STATUS, RP0		;1
	movlw 0xFF		;  , 
	movwf TRISC		;POTRC   
	bcf STATUS, RP0		;0
;----------------------
;-- Next Digit --
	rlf PORTA		;      
	movf INDF, W		;   ,   FSR
	call Table_7SEG		; ,   
	movwf PORTC		;,     
;-- Display On --------
	bsf STATUS, RP0		;1
	clrf TRISC		;   ,    
	bcf STATUS, RP0		;0
;---------------------------
	nop			;      -  
	nop			;     -0
;---------------------------
Digit_Cycle:			;    - ,  _0..
	btfss INTCON, TMR0IF	;..   
	goto Digit_Cycle	;  , ,   Digit_Cycle
;---------------------
	incf FSR		;     
	movf FSR, W		;,    FSR 
	addlw .220		; 220
	btfss STATUS, C		;  
	goto Display_Cycle	;  4 ,    
	goto Main_Cycle		;  4  ,    
;===============================
Table_7SEG:			;     ,   
				;  call
	addwf PCL		;      
				;        
	retlw b'11000000'	;"0"	
	retlw b'11111001'	;"1"
	retlw b'10100100'	;"2"
	retlw b'10110000'	;"3"
	retlw b'10011001'	;"4"
	retlw b'10010010'	;"5"
	retlw b'10000010'	;"6"
	retlw b'11111000'	;"7"
	retlw b'10000000'	;"8"
	retlw b'10010000'	;"9"
	nop			;blank
	nop			;blank
	nop			;blank
	nop			;blank
	nop			;blank
	nop			;blank
	retlw 0xFF		;blank digit -  ,   


;======================================
	end